
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Album_collaboratorsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const album_collaborators = await db.album_collaborators.create(
            {
                id: data.id || undefined,
        
        role: data.role
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        invited_at: data.invited_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await album_collaborators.setAlbum( data.album || null, {
            transaction,
        });
        
        await album_collaborators.setUser( data.user || null, {
            transaction,
        });
        
        await album_collaborators.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return album_collaborators;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const album_collaboratorsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                role: item.role
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                invited_at: item.invited_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const album_collaborators = await db.album_collaborators.bulkCreate(album_collaboratorsData, { transaction });

        // For each item created, replace relation files
        

        return album_collaborators;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const album_collaborators = await db.album_collaborators.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.role !== undefined) updatePayload.role = data.role;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.invited_at !== undefined) updatePayload.invited_at = data.invited_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await album_collaborators.update(updatePayload, {transaction});

        
        
        if (data.album !== undefined) {
            await album_collaborators.setAlbum(
              
              data.album,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await album_collaborators.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await album_collaborators.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return album_collaborators;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const album_collaborators = await db.album_collaborators.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of album_collaborators) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of album_collaborators) {
                await record.destroy({transaction});
            }
        });


        return album_collaborators;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const album_collaborators = await db.album_collaborators.findByPk(id, options);

        await album_collaborators.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await album_collaborators.destroy({
            transaction
        });

        return album_collaborators;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const album_collaborators = await db.album_collaborators.findOne(
            { where },
            { transaction },
        );

        if (!album_collaborators) {
            return album_collaborators;
        }

        const output = album_collaborators.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.album = await album_collaborators.getAlbum({
            transaction
        });
        
        
        output.user = await album_collaborators.getUser({
            transaction
        });
        
        
        output.organizations = await album_collaborators.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.albums,
        as: 'album',
        
        where: filter.album ? {
          [Op.or]: [
            { id: { [Op.in]: filter.album.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.album.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.invited_atRange) {
                const [start, end] = filter.invited_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    invited_at: {
                    ...where.invited_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    invited_at: {
                    ...where.invited_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.role) {
                where = {
                    ...where,
                role: filter.role,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.album_collaborators.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'album_collaborators',
                        'role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.album_collaborators.findAll({
            attributes: [ 'id', 'role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.role,
        }));
    }

    
};

